player = {
		 x = 400,
		 y = 300,
		 xoff = 9.5,
		 yoff = 9.5,
		 speed = 4,
		 rotation = 0,
		 nrotation = 1,
		 cgun = -12,
		 shootable = true,
		 shootspeed = 30,
		 lastshoot = 0,
		 bulletspeed = 18,
		 width = 57,
		 height = 57
	 }
wave = {
	 cwave = 1,
	 score = 0,
	 enemies = 10,
	 generated = false,
	 genemies = 0,
	 timer = 1,
	 lastgen = 0,
	 entities = 0
}
color1 = {
	 1,
	 165/255,
	 0
}
text_score = {
	 color1,
	 "Score"
}
text_cooldown = {
	 color1,
	 "Cooldown"
}
text_fps = {
	 color1,
	 "Fps"
}
bullets = {}
objects = {}
enemies = {}
fps = love.timer.getFPS( )
file = "scores.txt"
savegame = ""

function gun()
	  newBullet = { x = player.x + 19 , y = player.y + 14, img = bullet,rotation = 0,size = 5,direction = player.nrotation,width = 5,height = 5}
	 table.insert(bullets, newBullet)
	 player.shootable = false
	 player.lastshoot = player.shootspeed
	 love.audio.play(shoot[math.random(1,2)])
end
function checkcollision(a,b)
  if a.x > b.x + b.width or b.x > a.x + a.width then
    return false
  end
  if a.y > b.y + b.height or b.y > a.y + a.height then
    return false
  end
  return true
end
function savedata()
	 savegame = savegame.."enemies = {\n"
	 for i, enemy in ipairs(enemies) do	
		 if i ~= #enemies then
			 savegame = savegame.."\t {x = "..enemy.x..", y = "..enemy.y..", img = "..enemy.img..", lives = "..enemy.lives..", speed = "..enemy.speed.. ", size = "..enemy.size.."},\n"
		 else
			 savegame = savegame.."\t {x = "..enemy.x..", y = "..enemy.y..", img = "..enemy.img..", lives = "..enemy.lives..", speed = "..enemy.speed.. ", size = "..enemy.size.."}\n}\n"
		 end
	 end
	 savegame = savegame.."\nbullets = {\n"
	 for i,bullet in ipairs(bullets) do 
		 if i ~= #bullets then
			 savegame = savegame.."\t {direction = "..bullet.direction..", x = "..bullet.x..", y = "..bullet.y.."},\n"
		 else
			 savegame = savegame.."\t {direction = "..bullet.direction..", x = "..bullet.x..", y = "..bullet.y.."}\n"
		 end
	 end
	 savegame = savegame.."}\n"
	 savegame = savegame.."\nscore = "..wave.score.."\n"
end

function gameover()
	 function love.keypressed(key)
		 if key == "o" then
			 startgame()
		 end
	 end
	 function love.mousepressed(x,y,button)
		 x = x/window_scale_y
		 y = y/window_scale_y
		 if x >= 10 + window_translate_x and x <= 120 + window_translate_x and y >= 500 and y <= 560 then
			 love.system.openURL("https://joebrogers.itch.io/")
		 end
	 end
	 rotation = 0
	 function love.update()
		 fps = love.timer.getFPS( )
		 next_time = next_time + min_dt
		 rotation = rotation + 0.02
		 if rotation >= 6.28319 then
				 rotation = 0
		 end
		 local cur_time = love.timer.getTime()
		 if next_time <= cur_time then
		 next_time = cur_time
		 return
		 end
		 love.timer.sleep(next_time - cur_time)
	 end
	 function love.draw()
		 love.graphics.translate(window_translate_x,0)
		 love.graphics.scale(window_scale_x,window_scale_y)
		 love.graphics.print("Game Over",310,200,0,5,5)
		 love.graphics.print("press o to restart",330,300,0,2,2)
		 love.graphics.print("Font by\nJoeb Rogers",10,500,0,2,2)
		 love.graphics.print("Made by\nCaptainLK",700,500,0,2,2)
		 love.graphics.print("Your Score: "..wave.score.." P",340,500,0,2,2)
		 for i = 1,6,1 do
			 love.graphics.draw(e_graphics[1],e_3_layers[i],275,100 - i*4 + 30,rotation,5,5,9.5,9.5)
			 love.graphics.draw(e_graphics[2],e_3_layers[i],425,100 - i*4 + 30,rotation+1,5,5,9.5,9.5)
			 love.graphics.draw(e_graphics[3],e_3_layers[i],575,100 - i*4 + 30,rotation+2,5,5,9.5,9.5)
			 love.graphics.draw(guy,guy_graphics[i],425,400 - i*4 + 30,rotation,5,5,9.5,9.5)
		 end
	 end
end
function opengame()
	 function love.keypressed(key)
		 if key == "o" then
			 startgame()
		 end
	 end
	 function love.mousepressed(x,y,button)
		 x = x/window_scale_y
		 y = y/window_scale_y
		 if x >= 10 + window_translate_x and x <= 120 + window_translate_x and y >= 500 and y <= 560 then
			 love.system.openURL("https://joebrogers.itch.io/")
		 end
	 end
	 rotation = 0
	 function love.update()
		 fps = love.timer.getFPS( )
		 next_time = next_time + min_dt
		 rotation = rotation + 0.02
		 if rotation >= 6.28319 then
				 rotation = 0
		 end
		 local cur_time = love.timer.getTime()
		 if next_time <= cur_time then
		 next_time = cur_time
		 return
		 end
		 love.timer.sleep(next_time - cur_time)
	 end
	 function love.draw()
		 love.graphics.translate(window_translate_x,0)
		 love.graphics.scale(window_scale_x,window_scale_y)
		 love.graphics.print("Shooter",330,200,0,5,5)
		 love.graphics.print("press o to start",335,300,0,2,2)
		 love.graphics.print("Font by\nJoeb Rogers",10,500,0,2,2)
		 love.graphics.print("Made by\nCaptainLK",700,500,0,2,2)
		 for i = 1,6,1 do
			 love.graphics.draw(e_graphics[1],e_3_layers[i],275,100 - i*4 + 30,rotation,5,5,9.5,9.5)
			 love.graphics.draw(e_graphics[2],e_3_layers[i],425,100 - i*4 + 30,rotation+1,5,5,9.5,9.5)
			 love.graphics.draw(e_graphics[3],e_3_layers[i],575,100 - i*4 + 30,rotation+2,5,5,9.5,9.5)
			 love.graphics.draw(guy,guy_graphics[i],425,400 - i*4 + 30,rotation,5,5,9.5,9.5)
		 end
	 end
end
function startgame()
	 function love.keypressed(key)
	 
	 end
	 player = {
		 x = 400,
		 y = 300,
		 xoff = 9.5,
		 yoff = 9.5,
		 speed = 4,
		 rotation = 0,
		 nrotation = 1,
		 cgun = -12,
		 shootable = true,
		 shootspeed = 30,
		 lastshoot = 0,
		 bulletspeed = 18,
		 width = 45,
		 height = 45
	 }
	 wave = {
		 cwave = 1,
		 score = 0,
		 enemies = 10,
		 generated = false,
		 genemies = 0,
		 timer = 60,
		 lastgen = 0,
		 entities = 0
	 }
	 color1 = {
		 1,
		 165/255,
		 0
	 }
	 text_score = {
		 color1,
		 "Score"
	 }
	 text_cooldown = {
		 color1,
		 "Cooldown"
	 }
	 text_fps = {
		 color1,
		 "Fps"
	 }
	 bullets = {}
	 objects = {}
	 enemies = {}
	 fps = love.timer.getFPS( )
	 file = "scores.txt"
	 savegame = ""
	 collectgarbage()
	 function love.mousepressed(x,y,button)
	 
	 end
	 function love.draw()
		 love.graphics.translate(window_translate_x,0)
		 love.graphics.scale(window_scale_x,window_scale_y)
		 love.graphics.draw(back,0,60,0,3,3)
		 for i, bullet in ipairs(bullets) do
			 love.graphics.draw(bullet.img, bullet.x, bullet.y,bullet.rotation,bullet.size,bullet.size)
		 end
		 for i = 1,6,1 do
			 love.graphics.draw(guy,guy_graphics[i],player.x+player.xoff*3-6,player.y-i*2+player.yoff*3-6,player.rotation,3,3,player.xoff,player.yoff)
		 end
		 love.graphics.print(text_score,10,10,0,2,2)
		 love.graphics.print(wave.score,10,30,0,2,2)
		 love.graphics.print(text_cooldown,300,10,0,2,2)
		 love.graphics.print(player.lastshoot,300,30,0,2,2)
		 love.graphics.print(text_fps,650,10,0,2,2)
		 love.graphics.print(fps,650,30,0,2,2)
		 for i, enemy in ipairs(enemies) do
			 for o = 1,6,1 do
				 love.graphics.draw(e_graphics[enemy.img],e_3_layers[o],enemy.x + 30,enemy.y - o*3 + 30,enemy.rotation,3,3,9.5,9.5)
			 end
		 end
	 end


	 function love.update(dt)
		 fps = love.timer.getFPS( )
		 next_time = next_time + min_dt
		 -- movement --
		 if love.keyboard.isDown("right") or love.keyboard.isDown("d") then
			 player.x = player.x + player.speed
			 player.rotation = 0
			 player.nrotation = 1
		 elseif love.keyboard.isDown("left") or love.keyboard.isDown("a") then
			 player.x = player.x - player.speed
			 player.rotation = 3.14159
			 player.nrotation = 3
		 end
		 if love.keyboard.isDown("down") or love.keyboard.isDown("s") then
			 player.y = player.y + player.speed
			 player.rotation = 1.5708
			 player.nrotation = 2
		 elseif love.keyboard.isDown("up") or love.keyboard.isDown("w") then
			 player.y = player.y - player.speed
			 player.rotation = 4.71239
			 player.nrotation = 0
		 end
		 -- shooting --
		 if player.shootable == true then
			 gun()
		 end
		 for o, bullet in ipairs(bullets) do
			 if bullet.direction == 0 then
				 bullet.y = bullet.y - player.bulletspeed
			 elseif bullet.direction == 1 then
				 bullet.x = bullet.x + player.bulletspeed
			 elseif bullet.direction == 2 then
				 bullet.y = bullet.y + player.bulletspeed
			 elseif bullet.direction == 3 then
				 bullet.x = bullet.x - player.bulletspeed
			 end
			 if bullet.y < 0  or bullet.y > 600 or bullet.x < 0 or bullet.x > 800 then
				 table.remove(bullets, o)
			 else
				 for i,enemy in ipairs(enemies) do
					 if checkcollision(bullet,enemy) then
						 table.remove(bullets, o)
						 enemy.lives = enemy.lives - 1
						 if enemy.lives <= 0 then
							 table.remove(enemies,i)
							 love.audio.play(explode[math.random(1,3)])
							 wave.score = wave.score + enemy.img
						 end
					 end
				 end
			 end
		 end
		 if player.lastshoot == 0 then
			 player.shootable = true
		 elseif player.lastshoot > 0 then
			 player.lastshoot = player.lastshoot - 1
		 end
		 -- enemies --
		 if wave.lastgen == 0 then
			 local ne = math.random(1,3)
			 newenemie = {x = math.random(0,800),y = 70 , img = math.random(1,3), size = 3,speed = math.random(0.5,1),lives = 1,width = 57,height = 57,rotation = 0}
			 table.insert(enemies,newenemie)
			 wave.lastgen = wave.timer
		 end
		 for i, enemy in ipairs(enemies) do
			 if enemy.y > player.y then
				 enemy.y = enemy.y - 2
			 elseif enemy.y >= player.y and enemy.y <= player.y + player.width and enemy.x > player.x then
				 enemy.x = enemy.x - 2
			 elseif enemy.y >= player.y and enemy.y <= player.y + player.width and enemy.x < player.x then
				 enemy.x = enemy.x + 2
			 else
				 enemy.y = enemy.y + 2
			 end
			 enemy.rotation = enemy.rotation + 0.02
			 if enemy.rotation >= 6.28319 then
				 enemy.rotation = 0
			 end
		 end
		 if wave.lastgen ~= 0 then
			 wave.lastgen = wave.lastgen - 1
		 end
		 for i,enemy in ipairs(enemies) do
			 if checkcollision(player,enemy) then
				 love.filesystem.append( file, wave.score..", ")
				 savedata()
				 love.filesystem.write("save.lua",savegame)
				 gameover()
			 end
		 end
		 if wave.score > 50 and wave.score < 100 then
			 wave.timer = 50
		 elseif wave.score > 100 and wave.score < 150 then
			 wave.timer = 40
		 elseif wave.score > 150 and wave.score < 200 then
			 wave.timer = 30
		 elseif wave.score > 200 and wave.score < 250 then
			 wave.timer = 20
		 elseif wave.score > 250 and wave.score < 300 then
			 wave.timer = 10
		 elseif wave.score > 300 then
			 wave.timer = 1
		 end
		 if player.y > 580 then
			 player.y = player.y - player.speed
		 elseif player.y < 70 then
			 player.y = player.y + player.speed
		 end
		 if player.x < 10 then
			 player.x = player.x + player.speed
		 elseif player.x > 790 then
			 player.x = player.x - player.speed
		 end
		 move = math.random(0,2)
		 local cur_time = love.timer.getTime()
		 if next_time <= cur_time then
		 next_time = cur_time
		 return
		 end
		 love.timer.sleep(next_time - cur_time)
	 end
end

opengame()