function love.load()
	 local patht = "textures/tiles/"
	 local paths = "sounds/"
	 math.randomseed(os. time())
	 love.graphics.setDefaultFilter("nearest","nearest")
	 font = love.graphics.newFont("BitPotionExt.ttf", 16)
	 love.graphics.setFont(font)
	 guy = love.graphics.newImage(patht.."shooter.png")
	 guy_width,guy_height = guy:getDimensions()
	 guy_graphics = {}
	 bullet = love.graphics.newImage(patht.."bullet.bmp")
	 back = love.graphics.newImage(patht.."background.png")
	 e_graphics = {
		 love.graphics.newImage(patht.."enemie.png"),
		 love.graphics.newImage(patht.."enemie2.png"),
		 love.graphics.newImage(patht.."enemie3.png")
	 }
	 e_3_width,e_3_height = 114,19
	 e_3_layers = {}
	 for i = 0,e_3_width/19-1,1 do
		 newquad = love.graphics.newQuad(19*i,0,19,19,e_3_width,e_3_height)
		 table.insert(e_3_layers,newquad)
	 end
	 for i = 0,guy_width/19-1,1 do
		 newquad = love.graphics.newQuad(19*i,0,19,19,guy_width,guy_height)
		 table.insert(guy_graphics,newquad)
	 end
	 shoot = {
		 love.audio.newSource(paths.."shoot1.wav", "static"),
		 love.audio.newSource(paths.."shoot2.wav", "static")
	 }
	 explode = {
		 love.audio.newSource(paths.."explode1.wav", "static"),
		 love.audio.newSource(paths.."explode2.wav", "static"),
		 love.audio.newSource(paths.."explode3.wav", "static")
	 }
	 min_dt = 1/60
     next_time = love.timer.getTime()
	 width,height = love.graphics.getDimensions
	 window_width,window_height = love.graphics.getDimensions()
	 window_scale_y = window_height/600
	 window_scale_x = window_scale_y
	 window_translate_x = (window_width - (window_scale_x*800))/2
	 require("functions")
end